/*
 * TrimFSM.h
 *
 *  Created on: 23. 3. 2014
 *      Author: tomas
 */

#ifndef TRIMFSM_H_
#define TRIMFSM_H_

#include <algorithm>
#include <deque>
#include <set>

#include <AlibException.h>
#include <automaton/FSM/FSM.h>

#define isInSet(x,set) ( (set).find((x)) != (set).end())

class TrimFSM
{
public:
    /**
     * Removes dead states from FSM. Melichar 2.32
     */
    static automaton::FSM removeDeadStates( const automaton::FSM & fsm );

    /**
     * Removes dead states from FSM. Melichar 2.29
     */
    static automaton::FSM removeUnreachableStates( const automaton::FSM & fsm );
};

#endif /* TRIMFSM_H_ */
